Index: cppunit/src/cppunit/jni/Android.mk
===================================================================
--- cppunit/src/cppunit/jni/Android.mk	(revision 0)
+++ cppunit/src/cppunit/jni/Android.mk	(revision 0)
@@ -0,0 +1,67 @@
+LOCAL_PATH := $(call my-dir)/..
+
+# Set parameters once, settings for each project will be simpler then.
+include $(CLEAR_VARS)
+LOCAL_MODULE := cppunit
+# LOCAL_CFLAGS := -DNDEBUG
+LOCAL_C_INCLUDES := \
+    $(LOCAL_PATH)/../../include \
+    $(NDK_ROOT)/sources/cxx-stl/gnu-libstdc++/include \
+    $(NDK_ROOT)/sources/cxx-stl/gnu-libstdc++/libs/armeabi/include
+LOCAL_CPP_FEATURES := rtti exceptions
+# LOCAL_LDLIBS := -ldl -llog
+LOCAL_SRC_FILES:= \
+  AdditionalMessage.cpp \
+  Asserter.cpp \
+  BeOsDynamicLibraryManager.cpp \
+  BriefTestProgressListener.cpp \
+  CompilerOutputter.cpp \
+  DefaultProtector.cpp \
+  DynamicLibraryManager.cpp \
+  DynamicLibraryManagerException.cpp \
+  Exception.cpp \
+  Message.cpp \
+  RepeatedTest.cpp \
+  PlugInManager.cpp \
+  PlugInParameters.cpp \
+  Protector.cpp \
+  ProtectorChain.cpp \
+  SourceLine.cpp \
+  StringTools.cpp \
+  SynchronizedObject.cpp \
+  Test.cpp \
+  TestAssert.cpp \
+  TestCase.cpp \
+  TestCaseDecorator.cpp \
+  TestComposite.cpp \
+  TestDecorator.cpp \
+  TestFactoryRegistry.cpp \
+  TestFailure.cpp \
+  TestLeaf.cpp \
+  TestNamer.cpp \
+  TestPath.cpp \
+  TestPlugInDefaultImpl.cpp \
+  TestResult.cpp \
+  TestResultCollector.cpp \
+  TestRunner.cpp \
+  TestSetUp.cpp \
+  TestSuccessListener.cpp \
+  TestSuite.cpp \
+  TestSuiteBuilderContext.cpp \
+  TextOutputter.cpp \
+  TextTestProgressListener.cpp \
+  TextTestResult.cpp \
+  TextTestRunner.cpp \
+  TypeInfoHelper.cpp \
+  UnixDynamicLibraryManager.cpp \
+  ShlDynamicLibraryManager.cpp \
+  XmlDocument.cpp \
+  XmlElement.cpp \
+  XmlOutputter.cpp \
+  XmlOutputterHook.cpp \
+  Win32DynamicLibraryManager.cpp
+
+include $(BUILD_STATIC_LIBRARY)
+
+# If adding new libraries here, be sure to specify them in Application.mk too,
+# otherwise, they will not build, because nothing depends on them.
Index: cppunit/src/cppunit/jni/Application.mk
===================================================================
--- cppunit/src/cppunit/jni/Application.mk	(revision 0)
+++ cppunit/src/cppunit/jni/Application.mk	(revision 0)
@@ -0,0 +1,3 @@
+# This is here to force the creation of static libraries
+# without specifying any dependent library.
+APP_MODULES := cppunit
Index: cppunit/src/cppunit/jni/readme.txt
===================================================================
--- cppunit/src/cppunit/jni/readme.txt	(revision 0)
+++ cppunit/src/cppunit/jni/readme.txt	(revision 0)
@@ -0,0 +1,46 @@
+These makefiles allow to build cppunit static library
+for Android with the standalone toolchain.
+
+Prerequisites
+=============
+(Well, if you already develop native code for
+Android, you already should have everything.)
+Android NDK with all it's prerequisites:
+http://developer.android.com/sdk/ndk/index.html
+Apache Ant (if you don't use Eclipse):
+http://ant.apache.org/
+Cygwin if you are using Windows:
+http://www.cygwin.com/
+(Please Google for special cygwin setup steps for
+Android development.)
+
+
+Build process
+=============
+
+Go to the parent directory (cppunit/src/cppunit),
+and issue these commands (using cygwin under Windows):
+ndk-build
+ant release
+
+The library will be created here:
+cppunit/src/obj/local/armeabi/libcppunit.a
+
+Alternatively, it should be possible to use Eclipse.
+Then, Apache Ant is not needed. Actually, this is
+the reccommended way by Android, but it's not (yet)
+covered here in more detail.
+
+Yet another alternative would be to use vs-android,
+which allows Android development with Visual Studio.
+See http://code.google.com/p/vs-android/
+
+
+Using cppunit
+=============
+
+Well, this is still TODO.
+Please note that although I managed to compile
+cppuinit for Android with these makefiles, didn't
+test it yet, so, it might work without any problems,
+or it might not.